/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _OPACIFY_OPTIONS_H
#define _OPACIFY_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    OpacifyDisplayOptionToggleKey,
    OpacifyDisplayOptionToggleReset,
    OpacifyDisplayOptionTimeout,
    OpacifyDisplayOptionInitToggle,
    OpacifyDisplayOptionNum
} OpacifyDisplayOptions;

typedef void (*opacifyDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, OpacifyDisplayOptions num);

CompOption *opacifyGetDisplayOption (CompDisplay *d, OpacifyDisplayOptions num);

typedef enum
{
    OpacifyScreenOptionOnlyIfBlock,
    OpacifyScreenOptionFocusInstant,
    OpacifyScreenOptionNoDelayChange,
    OpacifyScreenOptionWindowMatch,
    OpacifyScreenOptionActiveOpacity,
    OpacifyScreenOptionPassiveOpacity,
    OpacifyScreenOptionNum
} OpacifyScreenOptions;

typedef void (*opacifyScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, OpacifyScreenOptions num);

CompOption *opacifyGetScreenOption (CompScreen *s, OpacifyScreenOptions num);

CompAction *     opacifyGetToggleKey (CompDisplay *d);
void             opacifySetToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             opacifySetToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     opacifyGetToggleKeyOption (CompDisplay *d);
void             opacifySetToggleKeyNotify (CompDisplay *d, opacifyDisplayOptionChangeNotifyProc notify);

Bool             opacifyGetToggleReset (CompDisplay *d);
CompOption *     opacifyGetToggleResetOption (CompDisplay *d);
void             opacifySetToggleResetNotify (CompDisplay *d, opacifyDisplayOptionChangeNotifyProc notify);

int              opacifyGetTimeout (CompDisplay *d);
CompOption *     opacifyGetTimeoutOption (CompDisplay *d);
void             opacifySetTimeoutNotify (CompDisplay *d, opacifyDisplayOptionChangeNotifyProc notify);

Bool             opacifyGetInitToggle (CompDisplay *d);
CompOption *     opacifyGetInitToggleOption (CompDisplay *d);
void             opacifySetInitToggleNotify (CompDisplay *d, opacifyDisplayOptionChangeNotifyProc notify);

Bool             opacifyGetOnlyIfBlock (CompScreen *s);
CompOption *     opacifyGetOnlyIfBlockOption (CompScreen *s);
void             opacifySetOnlyIfBlockNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

Bool             opacifyGetFocusInstant (CompScreen *s);
CompOption *     opacifyGetFocusInstantOption (CompScreen *s);
void             opacifySetFocusInstantNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

Bool             opacifyGetNoDelayChange (CompScreen *s);
CompOption *     opacifyGetNoDelayChangeOption (CompScreen *s);
void             opacifySetNoDelayChangeNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

CompMatch *      opacifyGetWindowMatch (CompScreen *s);
CompOption *     opacifyGetWindowMatchOption (CompScreen *s);
void             opacifySetWindowMatchNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

int              opacifyGetActiveOpacity (CompScreen *s);
CompOption *     opacifyGetActiveOpacityOption (CompScreen *s);
void             opacifySetActiveOpacityNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

int              opacifyGetPassiveOpacity (CompScreen *s);
CompOption *     opacifyGetPassiveOpacityOption (CompScreen *s);
void             opacifySetPassiveOpacityNotify (CompScreen *s, opacifyScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
