/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SHIFT_OPTIONS_H
#define _SHIFT_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    ShiftDisplayOptionInitiateKey,
    ShiftDisplayOptionInitiateButton,
    ShiftDisplayOptionInitiateEdge,
    ShiftDisplayOptionInitiateAllKey,
    ShiftDisplayOptionInitiateAllButton,
    ShiftDisplayOptionInitiateAllEdge,
    ShiftDisplayOptionTerminateButton,
    ShiftDisplayOptionNextKey,
    ShiftDisplayOptionNextButton,
    ShiftDisplayOptionPrevKey,
    ShiftDisplayOptionPrevButton,
    ShiftDisplayOptionNextAllKey,
    ShiftDisplayOptionNextAllButton,
    ShiftDisplayOptionPrevAllKey,
    ShiftDisplayOptionPrevAllButton,
    ShiftDisplayOptionNextGroupKey,
    ShiftDisplayOptionNextGroupButton,
    ShiftDisplayOptionPrevGroupKey,
    ShiftDisplayOptionPrevGroupButton,
    ShiftDisplayOptionNum
} ShiftDisplayOptions;

typedef void (*shiftDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, ShiftDisplayOptions num);

CompOption *shiftGetDisplayOption (CompDisplay *d, ShiftDisplayOptions num);

typedef enum
{
    ShiftScreenOptionSpeed,
    ShiftScreenOptionShiftSpeed,
    ShiftScreenOptionTimestep,
    ShiftScreenOptionWindowMatch,
    ShiftScreenOptionMinimized,
    ShiftScreenOptionMouseSpeed,
    ShiftScreenOptionClickDuration,
    ShiftScreenOptionMode,
    ShiftScreenOptionSize,
    ShiftScreenOptionBackgroundIntensity,
    ShiftScreenOptionHideAll,
    ShiftScreenOptionReflection,
    ShiftScreenOptionGroundColor1,
    ShiftScreenOptionGroundColor2,
    ShiftScreenOptionGroundSize,
    ShiftScreenOptionIntensity,
    ShiftScreenOptionFlipRotation,
    ShiftScreenOptionCoverOffset,
    ShiftScreenOptionOverlayIcon,
    ShiftScreenOptionMipmaps,
    ShiftScreenOptionMultioutputMode,
    ShiftScreenOptionWindowTitle,
    ShiftScreenOptionTitleFontFamily,
    ShiftScreenOptionTitleFontBold,
    ShiftScreenOptionTitleFontSize,
    ShiftScreenOptionTitleBackColor,
    ShiftScreenOptionTitleFontColor,
    ShiftScreenOptionTitleTextPlacement,
    ShiftScreenOptionNum
} ShiftScreenOptions;

typedef void (*shiftScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, ShiftScreenOptions num);

CompOption *shiftGetScreenOption (CompScreen *s, ShiftScreenOptions num);

typedef enum
{
    ModeCover = 0,
    ModeFlip = 1,
} ShiftModeEnum;

typedef enum
{
    OverlayIconNone = 0,
    OverlayIconEmblem = 1,
    OverlayIconBig = 2,
} ShiftOverlayIconEnum;

typedef enum
{
    MultioutputModeDisabled = 0,
    MultioutputModeOnActivatedOutput = 1,
    MultioutputModeOneBigSwitcher = 2,
} ShiftMultioutputModeEnum;

typedef enum
{
    TitleTextPlacementCenteredOnScreen = 0,
    TitleTextPlacementAbove = 1,
    TitleTextPlacementBelow = 2,
} ShiftTitleTextPlacementEnum;

CompAction *     shiftGetInitiateKey (CompDisplay *d);
void             shiftSetInitiateKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateKeyOption (CompDisplay *d);
void             shiftSetInitiateKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetInitiateButton (CompDisplay *d);
void             shiftSetInitiateButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateButtonOption (CompDisplay *d);
void             shiftSetInitiateButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetInitiateEdge (CompDisplay *d);
void             shiftSetInitiateEdgeInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateEdgeTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateEdgeOption (CompDisplay *d);
void             shiftSetInitiateEdgeNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetInitiateAllKey (CompDisplay *d);
void             shiftSetInitiateAllKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateAllKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateAllKeyOption (CompDisplay *d);
void             shiftSetInitiateAllKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetInitiateAllButton (CompDisplay *d);
void             shiftSetInitiateAllButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateAllButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateAllButtonOption (CompDisplay *d);
void             shiftSetInitiateAllButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetInitiateAllEdge (CompDisplay *d);
void             shiftSetInitiateAllEdgeInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetInitiateAllEdgeTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetInitiateAllEdgeOption (CompDisplay *d);
void             shiftSetInitiateAllEdgeNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetTerminateButton (CompDisplay *d);
void             shiftSetTerminateButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetTerminateButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetTerminateButtonOption (CompDisplay *d);
void             shiftSetTerminateButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextKey (CompDisplay *d);
void             shiftSetNextKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextKeyOption (CompDisplay *d);
void             shiftSetNextKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextButton (CompDisplay *d);
void             shiftSetNextButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextButtonOption (CompDisplay *d);
void             shiftSetNextButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevKey (CompDisplay *d);
void             shiftSetPrevKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevKeyOption (CompDisplay *d);
void             shiftSetPrevKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevButton (CompDisplay *d);
void             shiftSetPrevButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevButtonOption (CompDisplay *d);
void             shiftSetPrevButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextAllKey (CompDisplay *d);
void             shiftSetNextAllKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextAllKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextAllKeyOption (CompDisplay *d);
void             shiftSetNextAllKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextAllButton (CompDisplay *d);
void             shiftSetNextAllButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextAllButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextAllButtonOption (CompDisplay *d);
void             shiftSetNextAllButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevAllKey (CompDisplay *d);
void             shiftSetPrevAllKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevAllKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevAllKeyOption (CompDisplay *d);
void             shiftSetPrevAllKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevAllButton (CompDisplay *d);
void             shiftSetPrevAllButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevAllButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevAllButtonOption (CompDisplay *d);
void             shiftSetPrevAllButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextGroupKey (CompDisplay *d);
void             shiftSetNextGroupKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextGroupKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextGroupKeyOption (CompDisplay *d);
void             shiftSetNextGroupKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetNextGroupButton (CompDisplay *d);
void             shiftSetNextGroupButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetNextGroupButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetNextGroupButtonOption (CompDisplay *d);
void             shiftSetNextGroupButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevGroupKey (CompDisplay *d);
void             shiftSetPrevGroupKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevGroupKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevGroupKeyOption (CompDisplay *d);
void             shiftSetPrevGroupKeyNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

CompAction *     shiftGetPrevGroupButton (CompDisplay *d);
void             shiftSetPrevGroupButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             shiftSetPrevGroupButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     shiftGetPrevGroupButtonOption (CompDisplay *d);
void             shiftSetPrevGroupButtonNotify (CompDisplay *d, shiftDisplayOptionChangeNotifyProc notify);

float            shiftGetSpeed (CompScreen *s);
CompOption *     shiftGetSpeedOption (CompScreen *s);
void             shiftSetSpeedNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetShiftSpeed (CompScreen *s);
CompOption *     shiftGetShiftSpeedOption (CompScreen *s);
void             shiftSetShiftSpeedNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetTimestep (CompScreen *s);
CompOption *     shiftGetTimestepOption (CompScreen *s);
void             shiftSetTimestepNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

CompMatch *      shiftGetWindowMatch (CompScreen *s);
CompOption *     shiftGetWindowMatchOption (CompScreen *s);
void             shiftSetWindowMatchNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetMinimized (CompScreen *s);
CompOption *     shiftGetMinimizedOption (CompScreen *s);
void             shiftSetMinimizedNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetMouseSpeed (CompScreen *s);
CompOption *     shiftGetMouseSpeedOption (CompScreen *s);
void             shiftSetMouseSpeedNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetClickDuration (CompScreen *s);
CompOption *     shiftGetClickDurationOption (CompScreen *s);
void             shiftSetClickDurationNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetMode (CompScreen *s);
CompOption *     shiftGetModeOption (CompScreen *s);
void             shiftSetModeNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetSize (CompScreen *s);
CompOption *     shiftGetSizeOption (CompScreen *s);
void             shiftSetSizeNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetBackgroundIntensity (CompScreen *s);
CompOption *     shiftGetBackgroundIntensityOption (CompScreen *s);
void             shiftSetBackgroundIntensityNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetHideAll (CompScreen *s);
CompOption *     shiftGetHideAllOption (CompScreen *s);
void             shiftSetHideAllNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetReflection (CompScreen *s);
CompOption *     shiftGetReflectionOption (CompScreen *s);
void             shiftSetReflectionNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

unsigned short * shiftGetGroundColor1 (CompScreen *s);
unsigned short   shiftGetGroundColor1Red (CompScreen *s);
unsigned short   shiftGetGroundColor1Green (CompScreen *s);
unsigned short   shiftGetGroundColor1Blue (CompScreen *s);
unsigned short   shiftGetGroundColor1Alpha (CompScreen *s);
CompOption *     shiftGetGroundColor1Option (CompScreen *s);
void             shiftSetGroundColor1Notify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

unsigned short * shiftGetGroundColor2 (CompScreen *s);
unsigned short   shiftGetGroundColor2Red (CompScreen *s);
unsigned short   shiftGetGroundColor2Green (CompScreen *s);
unsigned short   shiftGetGroundColor2Blue (CompScreen *s);
unsigned short   shiftGetGroundColor2Alpha (CompScreen *s);
CompOption *     shiftGetGroundColor2Option (CompScreen *s);
void             shiftSetGroundColor2Notify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetGroundSize (CompScreen *s);
CompOption *     shiftGetGroundSizeOption (CompScreen *s);
void             shiftSetGroundSizeNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetIntensity (CompScreen *s);
CompOption *     shiftGetIntensityOption (CompScreen *s);
void             shiftSetIntensityNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetFlipRotation (CompScreen *s);
CompOption *     shiftGetFlipRotationOption (CompScreen *s);
void             shiftSetFlipRotationNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

float            shiftGetCoverOffset (CompScreen *s);
CompOption *     shiftGetCoverOffsetOption (CompScreen *s);
void             shiftSetCoverOffsetNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetOverlayIcon (CompScreen *s);
CompOption *     shiftGetOverlayIconOption (CompScreen *s);
void             shiftSetOverlayIconNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetMipmaps (CompScreen *s);
CompOption *     shiftGetMipmapsOption (CompScreen *s);
void             shiftSetMipmapsNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetMultioutputMode (CompScreen *s);
CompOption *     shiftGetMultioutputModeOption (CompScreen *s);
void             shiftSetMultioutputModeNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetWindowTitle (CompScreen *s);
CompOption *     shiftGetWindowTitleOption (CompScreen *s);
void             shiftSetWindowTitleNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

char *           shiftGetTitleFontFamily (CompScreen *s);
CompOption *     shiftGetTitleFontFamilyOption (CompScreen *s);
void             shiftSetTitleFontFamilyNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

Bool             shiftGetTitleFontBold (CompScreen *s);
CompOption *     shiftGetTitleFontBoldOption (CompScreen *s);
void             shiftSetTitleFontBoldNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetTitleFontSize (CompScreen *s);
CompOption *     shiftGetTitleFontSizeOption (CompScreen *s);
void             shiftSetTitleFontSizeNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

unsigned short * shiftGetTitleBackColor (CompScreen *s);
unsigned short   shiftGetTitleBackColorRed (CompScreen *s);
unsigned short   shiftGetTitleBackColorGreen (CompScreen *s);
unsigned short   shiftGetTitleBackColorBlue (CompScreen *s);
unsigned short   shiftGetTitleBackColorAlpha (CompScreen *s);
CompOption *     shiftGetTitleBackColorOption (CompScreen *s);
void             shiftSetTitleBackColorNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

unsigned short * shiftGetTitleFontColor (CompScreen *s);
unsigned short   shiftGetTitleFontColorRed (CompScreen *s);
unsigned short   shiftGetTitleFontColorGreen (CompScreen *s);
unsigned short   shiftGetTitleFontColorBlue (CompScreen *s);
unsigned short   shiftGetTitleFontColorAlpha (CompScreen *s);
CompOption *     shiftGetTitleFontColorOption (CompScreen *s);
void             shiftSetTitleFontColorNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

int              shiftGetTitleTextPlacement (CompScreen *s);
CompOption *     shiftGetTitleTextPlacementOption (CompScreen *s);
void             shiftSetTitleTextPlacementNotify (CompScreen *s, shiftScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
