/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _THUMBNAIL_OPTIONS_H
#define _THUMBNAIL_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    ThumbnailDisplayOptionNum
} ThumbnailDisplayOptions;

typedef void (*thumbnailDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, ThumbnailDisplayOptions num);

CompOption *thumbnailGetDisplayOption (CompDisplay *d, ThumbnailDisplayOptions num);

typedef enum
{
    ThumbnailScreenOptionThumbSize,
    ThumbnailScreenOptionShowDelay,
    ThumbnailScreenOptionBorder,
    ThumbnailScreenOptionThumbColor,
    ThumbnailScreenOptionFadeSpeed,
    ThumbnailScreenOptionCurrentViewport,
    ThumbnailScreenOptionAlwaysOnTop,
    ThumbnailScreenOptionWindowLike,
    ThumbnailScreenOptionMipmap,
    ThumbnailScreenOptionTitleEnabled,
    ThumbnailScreenOptionFontFamily,
    ThumbnailScreenOptionFontBold,
    ThumbnailScreenOptionFontSize,
    ThumbnailScreenOptionFontColor,
    ThumbnailScreenOptionNum
} ThumbnailScreenOptions;

typedef void (*thumbnailScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, ThumbnailScreenOptions num);

CompOption *thumbnailGetScreenOption (CompScreen *s, ThumbnailScreenOptions num);

int              thumbnailGetThumbSize (CompScreen *s);
CompOption *     thumbnailGetThumbSizeOption (CompScreen *s);
void             thumbnailSetThumbSizeNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

int              thumbnailGetShowDelay (CompScreen *s);
CompOption *     thumbnailGetShowDelayOption (CompScreen *s);
void             thumbnailSetShowDelayNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

int              thumbnailGetBorder (CompScreen *s);
CompOption *     thumbnailGetBorderOption (CompScreen *s);
void             thumbnailSetBorderNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

unsigned short * thumbnailGetThumbColor (CompScreen *s);
unsigned short   thumbnailGetThumbColorRed (CompScreen *s);
unsigned short   thumbnailGetThumbColorGreen (CompScreen *s);
unsigned short   thumbnailGetThumbColorBlue (CompScreen *s);
unsigned short   thumbnailGetThumbColorAlpha (CompScreen *s);
CompOption *     thumbnailGetThumbColorOption (CompScreen *s);
void             thumbnailSetThumbColorNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

float            thumbnailGetFadeSpeed (CompScreen *s);
CompOption *     thumbnailGetFadeSpeedOption (CompScreen *s);
void             thumbnailSetFadeSpeedNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetCurrentViewport (CompScreen *s);
CompOption *     thumbnailGetCurrentViewportOption (CompScreen *s);
void             thumbnailSetCurrentViewportNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetAlwaysOnTop (CompScreen *s);
CompOption *     thumbnailGetAlwaysOnTopOption (CompScreen *s);
void             thumbnailSetAlwaysOnTopNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetWindowLike (CompScreen *s);
CompOption *     thumbnailGetWindowLikeOption (CompScreen *s);
void             thumbnailSetWindowLikeNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetMipmap (CompScreen *s);
CompOption *     thumbnailGetMipmapOption (CompScreen *s);
void             thumbnailSetMipmapNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetTitleEnabled (CompScreen *s);
CompOption *     thumbnailGetTitleEnabledOption (CompScreen *s);
void             thumbnailSetTitleEnabledNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

char *           thumbnailGetFontFamily (CompScreen *s);
CompOption *     thumbnailGetFontFamilyOption (CompScreen *s);
void             thumbnailSetFontFamilyNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

Bool             thumbnailGetFontBold (CompScreen *s);
CompOption *     thumbnailGetFontBoldOption (CompScreen *s);
void             thumbnailSetFontBoldNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

int              thumbnailGetFontSize (CompScreen *s);
CompOption *     thumbnailGetFontSizeOption (CompScreen *s);
void             thumbnailSetFontSizeNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

unsigned short * thumbnailGetFontColor (CompScreen *s);
unsigned short   thumbnailGetFontColorRed (CompScreen *s);
unsigned short   thumbnailGetFontColorGreen (CompScreen *s);
unsigned short   thumbnailGetFontColorBlue (CompScreen *s);
unsigned short   thumbnailGetFontColorAlpha (CompScreen *s);
CompOption *     thumbnailGetFontColorOption (CompScreen *s);
void             thumbnailSetFontColorNotify (CompScreen *s, thumbnailScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
