/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "titleinfo_options.h"

static int TitleinfoOptionsDisplayPrivateIndex;

static CompMetadata titleinfoOptionsMetadata;

static CompPluginVTable *titleinfoPluginVTable = NULL;
CompPluginVTable titleinfoOptionsVTable;

#define TITLEINFO_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, TitleinfoOptions, o)
#define TITLEINFO_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, TitleinfoOptions, o)

typedef struct _TitleinfoOptionsDisplay
{
    int screenPrivateIndex;

} TitleinfoOptionsDisplay;

typedef struct _TitleinfoOptionsScreen
{
    CompOption opt[TitleinfoScreenOptionNum];
    titleinfoScreenOptionChangeNotifyProc notify[TitleinfoScreenOptionNum];
} TitleinfoOptionsScreen;

Bool titleinfoGetShowRemoteMachine (CompScreen *s)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    return os->opt[TitleinfoScreenOptionShowRemoteMachine].value.b;
}

CompOption * titleinfoGetShowRemoteMachineOption (CompScreen *s)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    return &os->opt[TitleinfoScreenOptionShowRemoteMachine];
}

void titleinfoSetShowRemoteMachineNotify (CompScreen *s, titleinfoScreenOptionChangeNotifyProc notify)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    os->notify[TitleinfoScreenOptionShowRemoteMachine] = notify;
}

Bool titleinfoGetShowRoot (CompScreen *s)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    return os->opt[TitleinfoScreenOptionShowRoot].value.b;
}

CompOption * titleinfoGetShowRootOption (CompScreen *s)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    return &os->opt[TitleinfoScreenOptionShowRoot];
}

void titleinfoSetShowRootNotify (CompScreen *s, titleinfoScreenOptionChangeNotifyProc notify)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    os->notify[TitleinfoScreenOptionShowRoot] = notify;
}

CompOption * titleinfoGetScreenOption (CompScreen *s, TitleinfoScreenOptions num)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo titleinfoOptionsScreenOptionInfo[] = {
    { "show_remote_machine", "bool", 0, 0, 0 },
    { "show_root", "bool", 0, 0, 0 },
};

static Bool titleinfoOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, TitleinfoScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case TitleinfoScreenOptionShowRemoteMachine:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[TitleinfoScreenOptionShowRemoteMachine])
                (*os->notify[TitleinfoScreenOptionShowRemoteMachine]) (s, o, TitleinfoScreenOptionShowRemoteMachine);
            return TRUE;
        }
        break;
     case TitleinfoScreenOptionShowRoot:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[TitleinfoScreenOptionShowRoot])
                (*os->notify[TitleinfoScreenOptionShowRoot]) (s, o, TitleinfoScreenOptionShowRoot);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * titleinfoOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    TITLEINFO_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = TitleinfoScreenOptionNum;
    return os->opt;
}

static Bool titleinfoOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    TitleinfoOptionsScreen *os;
    
    TITLEINFO_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(TitleinfoOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &titleinfoOptionsMetadata, titleinfoOptionsScreenOptionInfo, os->opt, TitleinfoScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void titleinfoOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    TITLEINFO_OPTIONS_SCREEN (s);
    TITLEINFO_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, TitleinfoScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool titleinfoOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    TitleinfoOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(TitleinfoOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[TitleinfoOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void titleinfoOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    TITLEINFO_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[TitleinfoOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool titleinfoOptionsInit (CompPlugin *p)
{
    TitleinfoOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (TitleinfoOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&titleinfoOptionsMetadata, "titleinfo",0, 0, titleinfoOptionsScreenOptionInfo, TitleinfoScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&titleinfoOptionsMetadata, "titleinfo");
    if (titleinfoPluginVTable && titleinfoPluginVTable->init)
        return titleinfoPluginVTable->init (p);
    return TRUE;
}

static void titleinfoOptionsFini (CompPlugin *p)
{
    if (titleinfoPluginVTable && titleinfoPluginVTable->fini)
        titleinfoPluginVTable->fini (p);

    if (TitleinfoOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (TitleinfoOptionsDisplayPrivateIndex);

    compFiniMetadata (&titleinfoOptionsMetadata);
}

static CompBool titleinfoOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) titleinfoOptionsInitDisplay,
        (InitPluginObjectProc) titleinfoOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void titleinfoOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) titleinfoOptionsFiniDisplay,
        (FiniPluginObjectProc) titleinfoOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool titleinfoOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = titleinfoOptionsInitObject (p, o);
    if (titleinfoPluginVTable->initObject)
        rv &= titleinfoPluginVTable->initObject (p, o);
    return rv;
}

static void titleinfoOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (titleinfoPluginVTable->finiObject)
        titleinfoPluginVTable->finiObject (p, o);
    titleinfoOptionsFiniObject (p, o);
}

static CompOption * titleinfoOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
        (GetPluginObjectOptionsProc) titleinfoOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool titleinfoOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) titleinfoOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
titleinfoOptionsGetMetadata (CompPlugin *plugin)
{
    return &titleinfoOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!titleinfoPluginVTable)
    {
        titleinfoPluginVTable = getCompPluginInfo ();
        memcpy(&titleinfoOptionsVTable, titleinfoPluginVTable, sizeof(CompPluginVTable));
        titleinfoOptionsVTable.getMetadata = titleinfoOptionsGetMetadata;
        titleinfoOptionsVTable.init = titleinfoOptionsInit;
        titleinfoOptionsVTable.fini = titleinfoOptionsFini;
        titleinfoOptionsVTable.initObject = titleinfoOptionsInitObjectWrapper;
        titleinfoOptionsVTable.finiObject = titleinfoOptionsFiniObjectWrapper;
        titleinfoOptionsVTable.getObjectOptions = titleinfoOptionsGetObjectOptions;
	titleinfoOptionsVTable.setObjectOption = titleinfoOptionsSetObjectOption;
	
    }
    return &titleinfoOptionsVTable;
}

