/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WORKAROUNDS_OPTIONS_H
#define _WORKAROUNDS_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    WorkaroundsDisplayOptionLegacyFullscreen,
    WorkaroundsDisplayOptionFirefoxMenuFix,
    WorkaroundsDisplayOptionOooMenuFix,
    WorkaroundsDisplayOptionNotificationDaemonFix,
    WorkaroundsDisplayOptionJavaFix,
    WorkaroundsDisplayOptionJavaTaskbarFix,
    WorkaroundsDisplayOptionQtFix,
    WorkaroundsDisplayOptionConvertUrgency,
    WorkaroundsDisplayOptionAiglxFragmentFix,
    WorkaroundsDisplayOptionFglrxXglFix,
    WorkaroundsDisplayOptionForceGlxSync,
    WorkaroundsDisplayOptionStickyAlldesktops,
    WorkaroundsDisplayOptionAlldesktopStickyMatch,
    WorkaroundsDisplayOptionNum
} WorkaroundsDisplayOptions;

typedef void (*workaroundsDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, WorkaroundsDisplayOptions num);

CompOption *workaroundsGetDisplayOption (CompDisplay *d, WorkaroundsDisplayOptions num);

typedef enum
{
    WorkaroundsScreenOptionNum
} WorkaroundsScreenOptions;

typedef void (*workaroundsScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, WorkaroundsScreenOptions num);

CompOption *workaroundsGetScreenOption (CompScreen *s, WorkaroundsScreenOptions num);

Bool             workaroundsGetLegacyFullscreen (CompDisplay *d);
CompOption *     workaroundsGetLegacyFullscreenOption (CompDisplay *d);
void             workaroundsSetLegacyFullscreenNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetFirefoxMenuFix (CompDisplay *d);
CompOption *     workaroundsGetFirefoxMenuFixOption (CompDisplay *d);
void             workaroundsSetFirefoxMenuFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetOooMenuFix (CompDisplay *d);
CompOption *     workaroundsGetOooMenuFixOption (CompDisplay *d);
void             workaroundsSetOooMenuFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetNotificationDaemonFix (CompDisplay *d);
CompOption *     workaroundsGetNotificationDaemonFixOption (CompDisplay *d);
void             workaroundsSetNotificationDaemonFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetJavaFix (CompDisplay *d);
CompOption *     workaroundsGetJavaFixOption (CompDisplay *d);
void             workaroundsSetJavaFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetJavaTaskbarFix (CompDisplay *d);
CompOption *     workaroundsGetJavaTaskbarFixOption (CompDisplay *d);
void             workaroundsSetJavaTaskbarFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetQtFix (CompDisplay *d);
CompOption *     workaroundsGetQtFixOption (CompDisplay *d);
void             workaroundsSetQtFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetConvertUrgency (CompDisplay *d);
CompOption *     workaroundsGetConvertUrgencyOption (CompDisplay *d);
void             workaroundsSetConvertUrgencyNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetAiglxFragmentFix (CompDisplay *d);
CompOption *     workaroundsGetAiglxFragmentFixOption (CompDisplay *d);
void             workaroundsSetAiglxFragmentFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetFglrxXglFix (CompDisplay *d);
CompOption *     workaroundsGetFglrxXglFixOption (CompDisplay *d);
void             workaroundsSetFglrxXglFixNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetForceGlxSync (CompDisplay *d);
CompOption *     workaroundsGetForceGlxSyncOption (CompDisplay *d);
void             workaroundsSetForceGlxSyncNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

Bool             workaroundsGetStickyAlldesktops (CompDisplay *d);
CompOption *     workaroundsGetStickyAlldesktopsOption (CompDisplay *d);
void             workaroundsSetStickyAlldesktopsNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

CompMatch *      workaroundsGetAlldesktopStickyMatch (CompDisplay *d);
CompOption *     workaroundsGetAlldesktopStickyMatchOption (CompDisplay *d);
void             workaroundsSetAlldesktopStickyMatchNotify (CompDisplay *d, workaroundsDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
